/*
 * callhome.c - Part of amprd version 2.0
 *
 * Author: Marius Petrescu, YO2LOJ, <marius@yo2loj.ro>
 *
 * ---------------------------------------
 *  To my son Marcel Petrescu (2005-2017)
 * ---------------------------------------
 *
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <time.h>

#include "callhome.h"
#include "commons.h"

static int hcount = 0;

void callhome(int alive)
{
    int sd;
    struct sockaddr_in sin;

    char *shutdown = "shutdown";

    if (homedata && (0 == hcount))
    {

	if ((sd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0)
	{
	    perror("call home socket():");
	    return;
	}

	bzero(&sin, sizeof(sin));
	sin.sin_family = AF_INET;
	sin.sin_addr.s_addr = CALLHOME_ADDRESS;
	sin.sin_port = htons(CALLHOME_PORT);

	if (debug) fprintf(stderr, "Calling home on port %d: %s\n", CALLHOME_PORT, homedata);

	if (alive)
	{
	    sendto(sd, homedata, strlen(homedata), 0, (struct sockaddr *)&sin, sizeof(sin));
	}
	else
	{
	    sendto(sd, shutdown, strlen(shutdown), 0, (struct sockaddr *)&sin, sizeof(sin));
	}
	hcount = CALLHOME_CYCLE * 2;
    }
    else
    {
	if (hcount) hcount--;
    }
}
